#!/bin/bash
#
# Egyszeru script a Java memoria elfogyasanak ellenorzesere valamennyi
# tomcat peldanyban.
# A mimoza-tomcat csomag resze.

DEFAULT="/etc/default"
ERROR="java.lang.OutOfMemoryError"
EXIT_ERR="1"
INIT="/etc/init.d"
LASTLINES=4
LOGBASE="/var/log/tomcat5.5"
LOGFILE="localhost.`date +%Y-%m-%d`.log"
SLEEPTIME="5"
TOMCAT="tomcat5.5"
TOMCAT_LIST=`ls -1 $DEFAULT/$TOMCAT.* 2>/dev/null | sed "s/^.*\/\(.*\.\)\(.*\)$/\2/"`
TOMCAT_SCRIPT="/usr/local/sbin/tomcat.sh"

# A beavatkozo scriptnek leteznie kell!

if [ ! -x $TOMCAT_SCRIPT ]; then
    echo -e "$0: Missing $TOMCAT_SCRIPT - exiting.\n"
    exit $EXIT_ERR
fi

# Sorbaveszi a letezo Tomcat-eket, es megvizsgalja a log utolso $LASTLINES sorat.
# Ha megtalalja az $ERROR szoveget, ujraindit.

for current_tomcat in $TOMCAT_LIST
do 
    if [ -f $LOGBASE/$current_tomcat/$LOGFILE ]; then
        if [ ! -z "`tail -n $LASTLINES $LOGBASE/$current_tomcat/$LOGFILE | grep -i $ERROR`" ] ; then
            echo "$0: $ERROR detected - restarting $current_tomcat"
            $TOMCAT_SCRIPT $current_tomcat restart
	    sleep $SLEEPTIME
            $TOMCAT_SCRIPT $current_tomcat status
	fi
    fi
done
